﻿// <auto-generated />
using System;
using Microsoft.EntityFrameworkCore;
using Microsoft.EntityFrameworkCore.Infrastructure;
using Microsoft.EntityFrameworkCore.Storage.ValueConversion;
using Npgsql.EntityFrameworkCore.PostgreSQL.Metadata;
using TarefaApi.Model;

namespace tarefas_api.Migrations
{
    [DbContext(typeof(ApiDbContext))]
    partial class TarefaContextModelSnapshot : ModelSnapshot
    {
        protected override void BuildModel(ModelBuilder modelBuilder)
        {
#pragma warning disable 612, 618
            modelBuilder
                .HasAnnotation("Npgsql:ValueGenerationStrategy", NpgsqlValueGenerationStrategy.SerialColumn)
                .HasAnnotation("ProductVersion", "2.2.6-servicing-10079")
                .HasAnnotation("Relational:MaxIdentifierLength", 63);

            modelBuilder.Entity("TarefaApi.Model.Arquivo", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd();

                    b.Property<string>("Caminho");

                    b.Property<int?>("TarefaId");

                    b.HasKey("Id");

                    b.HasIndex("TarefaId");

                    b.ToTable("Arquivos");
                });

            modelBuilder.Entity("TarefaApi.Model.Execucao", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd();

                    b.Property<DateTime?>("DataConclusao");

                    b.Property<int>("PorcentagemConcluida");

                    b.Property<int>("Status");

                    b.Property<int>("TarefaId");

                    b.HasKey("Id");

                    b.HasIndex("TarefaId")
                        .IsUnique();

                    b.ToTable("Execucoes");
                });

            modelBuilder.Entity("TarefaApi.Model.Responsavel", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd();

                    b.Property<string>("Nome");

                    b.Property<int?>("TarefaId");

                    b.HasKey("Id");

                    b.HasIndex("TarefaId");

                    b.ToTable("Responsavel");
                });

            modelBuilder.Entity("TarefaApi.Model.Tarefa", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd();

                    b.Property<string>("Descricao");

                    b.Property<int>("Prioridade");

                    b.HasKey("Id");

                    b.ToTable("Tarefas");
                });

            modelBuilder.Entity("TarefaApi.Model.TarefaResponsavel", b =>
                {
                    b.Property<int>("TarefaId");

                    b.Property<int>("ResponsavelId");

                    b.HasKey("TarefaId", "ResponsavelId");

                    b.HasIndex("ResponsavelId");

                    b.ToTable("TarefaResponsavel");
                });

            modelBuilder.Entity("TarefaApi.Model.Arquivo", b =>
                {
                    b.HasOne("TarefaApi.Model.Tarefa")
                        .WithMany("Arquivos")
                        .HasForeignKey("TarefaId");
                });

            modelBuilder.Entity("TarefaApi.Model.Execucao", b =>
                {
                    b.HasOne("TarefaApi.Model.Tarefa", "Tarefa")
                        .WithOne("Execucao")
                        .HasForeignKey("TarefaApi.Model.Execucao", "TarefaId")
                        .OnDelete(DeleteBehavior.Cascade);
                });

            modelBuilder.Entity("TarefaApi.Model.Responsavel", b =>
                {
                    b.HasOne("TarefaApi.Model.Tarefa")
                        .WithMany("Responsaveis")
                        .HasForeignKey("TarefaId");
                });

            modelBuilder.Entity("TarefaApi.Model.TarefaResponsavel", b =>
                {
                    b.HasOne("TarefaApi.Model.Responsavel", "Responsavel")
                        .WithMany("TarefaResponsaveis")
                        .HasForeignKey("ResponsavelId")
                        .OnDelete(DeleteBehavior.Cascade);

                    b.HasOne("TarefaApi.Model.Tarefa", "Tarefa")
                        .WithMany("TarefaResponsaveis")
                        .HasForeignKey("TarefaId")
                        .OnDelete(DeleteBehavior.Cascade);
                });
#pragma warning restore 612, 618
        }
    }
}
